/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "defs.h"
#include "abimport.h"
#include "proto.h"


//***************************************************************************
int
New_config( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
     PtArg_t     arg[2];
     char       *tmp; 
     uchar_t    *state;
     PtWidget_t *wgt;


     for(wgt = PtWidgetChildBack( ABW_OrderGroup ); wgt != NULL; 
            wgt = PtWidgetBrotherInFront( wgt ) )
     {
      PtSetArg( &arg[0], Pt_ARG_USER_DATA, &state, 0 );
      PtGetResources(wgt, 1, arg);
      if(state != NULL && *state != 0)
       {
        SetSortOrder(ApName(wgt));
       }
     }

     PtSetArg( &arg[0], Pt_ARG_CBOX_TEXT_STRING, &tmp, 0 );
     PtGetResources(ABW_Node, 1, arg);
     if(node != atol(tmp))
      {
       node = atol(tmp);
       SetNode();
       ListFree(&tasks);
      }

     PtSetArg( &arg[0], Pt_ARG_TEXT_STRING, &tmp, 0 );
     PtGetResources(ABW_Rate, 1, arg);
     rate = atol(tmp);
     if(rate <= 0) rate = 500;
     SetRate();

     PtDestroyWidget( ABW_Config_dlg );

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}


//***************************************************************************
void SetSortOrder(int mode)
{

 if( mode == ABN_Res_b )
  {
   comp = &CompRes;
  }
 else if( mode == ABN_Mem_b )
  {
   comp = &CompMem;
  }
 else if( mode == ABN_Name_b )
  {
   comp = &CompName;
  }
 else if( mode == ABN_Pid_b )
  {
   comp = &CompPid;
  }
 else if( mode == ABN_None_b )
  {
   comp = NULL;
  }
}

//***************************************************************************
int CompRes(P_INFO *a, P_INFO *b)
{
 
 if( a->delta > b->delta ) return -1;
 else return 1;

}

//***************************************************************************
int CompMem(P_INFO *a, P_INFO *b)
{
 
 if( a->mem > b->mem ) return -1;
 else return 1;

}

//***************************************************************************
int CompName(P_INFO *a, P_INFO *b)
{

 return( strcmp(a->name, b->name) );
}

//***************************************************************************
int CompPid(P_INFO *a, P_INFO *b)
{
 
 if( a->pid < b->pid ) return -1;
 else return 1;

}

