#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#define _list_

#include "list.h"
 
 
int ListIn(LIST **elem, int pos, void *data, int size)
/************************************************************************
pos = 1  -  砫
pos = -1 -  
*************************************************************************/
{
LIST *tmp;
LIST *before;
LIST *after;
LIST *cell = *elem;
// int count;

 after = ListPos(&cell, pos);
 before = after;
  
 if(after == NULL)
  {
   if(pos >= 0)
   	 before = ListLast(&cell);
   else
     after = ListFirst(&cell);
  }

 if(pos >= 0)
  {
    if(after != NULL) before = after->prev;
    else if(before != NULL) after = before->next;
  }
  else
   {
    if(before != NULL) after = before->next;
    else if(after != NULL) before = after->prev;
  }

 tmp = (LIST *)malloc(sizeof(LIST));
 if(tmp == NULL) return 0;

 tmp->data = (char *)malloc(size);
 if(tmp->data == NULL) return 0;
 
 tmp->prev = before;
 tmp->next = after;
 if(before != NULL) before->next = tmp;
 if(after != NULL) after->prev = tmp;

 memcpy(tmp->data, data, size);
 tmp->size = size;

 *elem = tmp;
 
 return(pos);
} 




int ListDel(LIST **elem, int pos)
/************************************************************************
pos = 1  - 
pos = -1 - ᫥
*************************************************************************/
{
LIST *cell = *elem;

 cell = ListPos(&cell, pos);
 if(cell == NULL) return(0);

 if((cell->next == NULL) && (cell->prev == NULL)) //    ᯨ᪥
     *elem = NULL;

 else 
  {
   if(cell->prev != NULL)
    {
     cell->prev->next = cell->next;
     *elem = cell->prev;
    }
   if(cell->next != NULL) 
    {
     cell->next->prev = cell->prev;
     *elem = cell->next;
    }
  }


 free(cell->data);
 free(cell);

 return(pos);
}




LIST *ListNext(LIST **elem)
/************************************************************************
*************************************************************************/
{
LIST *cell = *elem;

 if(cell == NULL) 
   return(NULL);

 if(cell->next != NULL)
   *elem = cell->next;

 cell = cell->next;
  
 return(cell);
} 



LIST *ListPrev(LIST **elem)
/************************************************************************
*************************************************************************/
{
LIST *cell = *elem;

 if(cell == NULL) 
   return(NULL);

 if(cell->prev != NULL)
   *elem = cell->prev;

 cell = cell->prev;
  
 return(cell);
} 


LIST *ListFirst(LIST **elem)
/************************************************************************
*************************************************************************/
{
LIST *cell = *elem;

 if(cell == NULL) 
   return(NULL);

 while(ListPrev(&cell) != NULL);

 *elem = cell;

 return(cell);
} 


LIST *ListLast(LIST **elem)
/************************************************************************
*************************************************************************/
{
LIST *cell = *elem;

 if(cell == NULL) 
   return(NULL);

 while(ListNext(&cell) != NULL);

 *elem = cell;

 return(cell);
} 



LIST *ListPos(LIST **elem, int pos)
/************************************************************************
pos = 1  - 
pos = -1 - ᫥
*************************************************************************/
{
LIST *cell = *elem;
int i;

 if(cell == NULL) return(NULL);

 if(pos == 0) return(cell);
 
 if(pos > 0)
  {
   cell = ListFirst(&cell);

   for(i = 1; i < pos && cell != NULL; i++)
	 cell = ListNext(&cell);

   if(cell != NULL)
    *elem = cell;

   return(cell);
  }
 else
   cell = ListLast(&cell);

   for(i = -1; i > pos && cell != NULL; i--)
	 cell = ListNext(&cell);

   if(cell != NULL)
    *elem = cell;

   return(cell);
} 




int ListFree(LIST **elem)
/*************************************************************************/
{
LIST *cell = *elem;

 if(cell == NULL) return(-1);

 while(ListDel(&cell, 1));
  
 *elem = NULL;
 return(0);       
 
} 



int ListFind(LIST **elem, void *data, int size, int shift)
/************************************************************************/
{
LIST *cell = *elem;
static int i;
int j;

 if(cell == NULL) return(0);
 
 i = 1;
 j = ListCount(&cell);
 ListPos(&cell, 1);
 do
  {
   if(!memcmp((cell->data) + shift, data, size)) 
    {
     *elem = cell;
     return(i);
    }
   i++;
   if(j < i) break;
  } while(ListNext(&cell) != NULL);

  
 return(0);       
 
} 



int ListCount(LIST **elem)
/*************************************************************************/
{
LIST *cell = *elem;
static int i;

 if(cell == NULL) return(0);

 cell = ListFirst(&cell);

 i = 1;

 while(ListNext(&cell) != NULL) i++;
            
 return(i);       
} 

int ListSwap(LIST **elem, int n, int k)
/***************************************************************************/
{
LIST *a, *b, *tmp;

if(elem == NULL) return -1;
if(n == k) return 0;
else
 {
  a = ListPos(elem, k);
  b = ListPos(elem, n);
  if((k - n) != 1)                  // ᫨  冷
   {
    if(a->prev) a->prev->next = b; 
    if(b->next) b->next->prev = a; 
   }
  if((n - k) != 1)
   {
    if(a->next) a->next->prev = b; 
    if(b->prev) b->prev->next = a; 
   }
  tmp = a->next;

  if((k - n) != 1)
   a->next = b->next;
  else
   a->next = b;

  if((n - k) != 1)
   b->next = tmp;
  else 
   b->next = a;

  tmp = a->prev;

  if((n - k) != 1)
   a->prev = b->prev;
  else
   a->prev = b;

  if((k - n) != 1)
   b->prev = tmp;
  else
   b->prev = a;
 }

return 1;
}

/****************************************************************************/
void ListSort( LIST **elem, int (*comp)(void *, void*), short order)
{
LIST *a, *b, *tmp;
int i, j;

    if(elem == NULL || comp == NULL) return;

    a = ListFirst(elem);
    i = 1;
    
    while(a != NULL)
     {
      b = a;
      b = ListNext(&b);
      j = i + 1;
      while(b != NULL)
       {
        if(( comp(a->data, b->data) > 0 && order == ASC ) || 
           ( comp(a->data, b->data) < 0 && order == DESC) ) 
         {
          ListSwap(elem, i, j);
          tmp = a; a = b; b = tmp;
         }
        b = ListNext(&b);
        j++;
       }
      a = ListNext(&a);
      i++;
     }
}
