/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "defs.h"
#include "abimport.h"
#include "proto.h"

int
resize( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
     PhDim_t     *old_size, size;
     PhPoint_t   *pos, newpos;
     PhDim_t     *dim, newdim;
     PtArg_t     arg[3];
     char        *user;
     PhRect_t    *extents = (PhRect_t *)cbinfo->cbdata;
     int         width = extents->lr.x - extents->ul.x + 1;
     int         height = extents->lr.y - extents->ul.y + 1;
     PtWidget_t *wgt = PtWidgetChildBack( widget );

     PtSetArg( &arg[0], Pt_ARG_USER_DATA, &old_size, 0 );
     PtGetResources(widget, 1, arg);

     if( old_size )
      {
       for(; wgt; wgt = PtWidgetBrotherInFront( wgt ) )
        {

         PtSetArg(&arg[0], Pt_ARG_POS, &pos, 0);
         PtSetArg(&arg[1], Pt_ARG_DIM, &dim, 0);
         PtSetArg(&arg[2], Pt_ARG_USER_DATA, &user, 0);
         PtGetResources(wgt, 3, arg);

         if ( dim && pos && user )
         {
          newpos = *pos;
          newdim = *dim;

          while ( *user != NULL )
           {
            switch ( *(short *)user )
             {
              case 'Tt': break;
              case 'Bt': newpos.y += (height-old_size->h); break;
              case 'Tb': break;
              case 'Bb': newdim.h += (height-old_size->h); break;
              case 'Rl': newpos.x += (width-old_size->w); break;
              case 'Ll': break;
              case 'Rr': newdim.w += (width-old_size->w); break;
              case 'Lr': break;
             }
            user += sizeof(short);
           }

            PtSetArg(&arg[0], Pt_ARG_DIM, &newdim, 0);
            PtSetArg(&arg[1], Pt_ARG_POS, &newpos, 0);
            PtSetResources(wgt, 2, arg);
            PtRealizeWidget(wgt);
         }
       }  
     }
    
	 size.w = width;
	 size.h = height;
     PtSetArg( &arg[0], Pt_ARG_USER_DATA, &size, sizeof( PhDim_t ) );
     PtSetResources(widget, 1, arg);


	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

