/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <math.h>

#include <sys/dev.h>
#include <sys/kernel.h>
#include <sys/psinfo.h>
#include <sys/proxy.h>
#include <sys/osinfo.h>
#include <sys/times.h>
#include <sys/vc.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

#define _MAIN_

/* Local headers */
#include "abimport.h"
#include "defs.h"
#include "proto.h"

void draw_tmp( PtWidget_t *widget, PhTile_t *damage );

//***************************************************************************
int
setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
	{
	PtArg_t argt[2];
	PhDim_t dim;
	int n = 0;

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	PtWidgetDim( ABW_Tasks_pane, &dim );
	PtSetArg( &argt[n++], Pt_ARG_RAW_DRAW_F, draw_tmp, 0 );
	PtSetArg( &argt[n++], Pt_ARG_DIM, &dim, 0 );
	PtRealizeWidget( PtCreateWidget( PtRaw, ABW_Tasks_pane, n, argt ) );
    init_trend();
    init_timer();

	return( Pt_CONTINUE );

	}

//**************************************************************************
int draw(void *data, pid_t pid, void *mess, size_t size)
{
PtArg_t         arg[10];
char            pers[20];
float           scale = 1000.0;
static long     count;
static short    new_val[2];

  data=data; pid=pid; mess=mess; size=size;

   while( Creceive(pid, NULL, 0) == pid ); // delete useless messages
   
   calc_res(&val[0]);
   new_val[0] = smooth(new_val[0], scale * (1.0 - (float)val[0].free / (float)val[0].total));

   sprintf(pers, "%4d %%", 100 * val[0].free / val[0].total);
   PtSetArg(&arg[0], Pt_ARG_TEXT_STRING, pers, 0);
   PtSetResources(ABW_Res, 1, arg);
   PtRealizeWidget(ABW_Res);

//   if( (count % 10) == 0 )   // every 10th time
//    {
     calc_mem(&val[1]);
     
     if(val[1].free < 1000)
       sprintf(pers, "%4ld k", val[1].free);
     else
       sprintf(pers, "%4.1f M", (float)val[1].free / 1000.0);
     
     PtSetArg(&arg[0], Pt_ARG_TEXT_STRING, pers, 0);
     PtSetResources(ABW_Mem, 1, arg);
     PtRealizeWidget(ABW_Mem);
//    }
   new_val[1] = smooth(new_val[1], scale * (1.0 - (float)val[1].free / (float)val[1].total));

   PtSetArg(&arg[0], Rt_ARG_TREND_DATA, &new_val, 2);
   PtSetResources(ABW_Trend, 1, arg);
//   PtRealizeWidget(ABW_Trend);
  
   ListSort(&tasks, comp, ASC);
//QNXD   draw_tmp();
PtDamageWidget( ABW_Tasks_pane );
PtUpdate();   
   if(PtWindowGetState(ABW_base) & Ph_WM_STATE_ISICONIFIED)
    {
     change_title(1);
    }

   count ++;
return( Pt_CONTINUE );
}

//**************************************************************************
void calc_res(INFO *info)
{
long total = 0, idle;
LIST *lst;
P_INFO *task;

 Get_res();
 
 for( lst=ListFirst(&tasks); lst != NULL; lst = ListNext(&lst) )
  {
   task = (P_INFO *)lst->data;
   total += task->delta;
   
   if(!strcmp("idle", task->name))
    {
     idle = task->delta;
    }
  }

  info->free =  idle ;
  info->total = ( total ? total : 1 ) ;
  
return;
}

//**************************************************************************
void calc_mem(INFO *info)
{
struct _osinfo data;

 qnx_osinfo(node, &data);

 info->free = data.freememk;
 info->total = data.totmemk;

return;
}

//**************************************************************************
int init_timer(void)
{
     struct sigevent   my_time_event;

     t_proxy = qnx_proxy_attach( 0, 0, 0, -1 );
     if(t_proxy == -1)
      {
       perror("\nproxy");
       return -1;
      }
  
     my_time_event.sigev_signo = -t_proxy;
     time_id = timer_create(CLOCK_REALTIME, &my_time_event);
     if(time_id == -1)
     {       
		perror("\ntimer");
       return -2;
      }

      PtAppAddInput(NULL, t_proxy, &draw, NULL);

      rate = 500L;
      SetRate();

return 0;
}

//**************************************************************************
short smooth(short old, short new)
{
static short sm;
 
 sm = (old + new) / 2;
 

 return( sm );
}

//****************************************************************************
void SetRate(void)
{
 struct itimerspec my_timer;

     my_timer.it_value.tv_sec          =  rate / 1000L;  
     my_timer.it_value.tv_nsec         =  ( rate % 1000L ) * 1000000L;  
     my_timer.it_interval.tv_sec       =  rate / 1000L;  
     my_timer.it_interval.tv_nsec      =  ( rate % 1000L ) * 1000000L;  
 
     timer_settime(time_id, 0, &my_timer, NULL);

}

//****************************************************************************
void SetNode(void)
{
char Msg[40];

 if( vpid ) qnx_vc_detach(vpid);

 vpid = qnx_vc_attach(node, PROC_PID, 1000, 0);
 if( vpid == -1 )
  {
   sprintf(Msg, "Unable to locate node %ld ", node);
   ApError(ABW_base, errno, "SysTrend", Msg, NULL);
   node = 0;
   vpid = PROC_PID;
  }
}

//*****************************************************************************
void RemoveDeads( clock_t now )
{
P_INFO *p_task;
   
  if(tasks == NULL) return;
  tasks = ListFirst(&tasks);

  do
   {
    p_task = (P_INFO *)tasks->data;
    if( p_task->alive < now )
     {
      ListDel(&tasks, 0);
     }
   } while( ListNext(&tasks) != NULL );
}

//***************************************************************************
void Get_res(void)
{
struct _psinfo Pdata;
struct _seginfo Sdata [16];
pid_t pid;
P_INFO info;
P_INFO *p_info;
clock_t now = clock();
char *real_name;
int index;

 for(pid = 1;; pid++)
  {
	pid = qnx_psinfo (vpid, pid, &Pdata, 0, &Sdata);
    if( pid == -1 ) break;

	if ((Pdata.flags & (_PPF_MID | _PPF_VID)) == 0) 
     {
      if( ListFind(&tasks, &pid, sizeof(pid_t), (int)(&info.pid)-(int)(&info)) != 0 )
       {
        p_info = (P_INFO *)tasks->data;
        p_info->mem = 0;
		for (index = 0; index < Pdata.un.proc.nselectors; index++) 
         {
		  p_info->mem += Sdata[index].nbytes;
		 }
        p_info->delta = p_info->total;
	    p_info->total = Pdata.un.proc.times.tms_cutime + Pdata.un.proc.times.tms_cstime
             + Pdata.un.proc.times.tms_stime + Pdata.un.proc.times.tms_utime;
        p_info->delta = p_info->total - p_info->delta;
        p_info->alive = now;
       }
      
      else   // not found
       {
        info.pid = pid;
		real_name = strrchr(Pdata.un.proc.name, '/');
        if(real_name) real_name++;
        else real_name = &Pdata.un.proc.name[0];
		strncpy(info.name, real_name, 19);
        info.name[19] = '\0';
        info.mem = 0;
		for (index = 0; index < Pdata.un.proc.nselectors; index++) 
         {
		  info.mem += Sdata[index].nbytes;
		 }
	    info.total = Pdata.un.proc.times.tms_cutime + Pdata.un.proc.times.tms_cstime
             + Pdata.un.proc.times.tms_stime + Pdata.un.proc.times.tms_utime;
        info.delta = 0;
        info.alive = now;
        ListIn(&tasks, 0, &info, sizeof(P_INFO));
       }
      
     }
    else continue;
  }

 RemoveDeads( now );

return;
}


//***************************************************************************
//void draw_tmp(void)
void draw_tmp( PtWidget_t *widget, PhTile_t *damage )
{
//    static PhGC_t *my_gc;
//    PhGC_t *old_gc = PgGetGC();
    PhRect_t rect, slider;
    PhPoint_t pos;
    int i;
    float scale;
    unsigned short size;
    P_INFO *tsk;
    LIST *lst;
    pid_t my_pid = getpid();

// Init my GC

#if 0
    if( my_gc == NULL)
     {
      my_gc = PgCreateGC( 0 );
      PgSetGC( my_gc );
      PgSetRegion(ABW_base->rid);
     }
    else
     {
      PgSetGC( my_gc );
     }
#endif 
      PgSetFont("helv10");
      PgSetTextColor( Pg_BLACK );

// Erase all

//   PtBasicWidgetCanvas(ABW_Tasks_pane, &rect );
   PtWidgetExtent( widget, &rect );
   PgSetFillColor( Pg_GRAY );
   PgDrawRect( &rect, Pg_DRAW_FILL);
   rect.ul.x+=80;
   scale = (rect.lr.x - rect.ul.x - 1);

// Draw grid

   pos.x = 4;
   pos.y = 0;
   memcpy(&slider, &rect, sizeof(PhRect_t));
   slider.lr.y = slider.ul.y + 4;
   PgSetStrokeColor( Pg_BLACK );
   PgDrawILine(slider.ul.x, slider.ul.y, slider.lr.x, slider.ul.y);
   PgDrawGrid( &slider, &pos );

// Draw info   

#if 1
   for( lst = ListFirst(&tasks), i = 0; lst != NULL;lst = ListNext(&lst) )
    {
     PgSetStrokeColor( Pg_GREEN );
     PgSetFillColor( Pg_RED );
     tsk = (P_INFO *)lst->data;
     size = (float)tsk->delta * scale / val[0].total;
     if(size > scale) size = scale;
     if( size > 0 && strcmp(tsk->name, "idle") != 0 )  i++;
     else    continue;
     if(tsk->pid == my_pid && size > (scale/2)) // too fast
      {
       rate++;
       SetRate();
      }
     slider.ul.x = rect.ul.x + 1;
     slider.ul.y = rect.ul.y + (12 * i);
     slider.lr.x = slider.ul.x + size;
     slider.lr.y = slider.ul.y + 3;
     if( (slider.lr.y+5) > rect.lr.y ) break;
     PgDrawRect( &slider , Pg_DRAW_FILL );

     PgSetStrokeColor( Pg_RED );
     PgSetFillColor( Pg_GREEN );
     slider.ul.y += 4;
     slider.lr.x = slider.ul.x + (float)(tsk->mem >> 10) * scale / val[1].total;
     slider.lr.y += 4;
     PgDrawRect( &slider , Pg_DRAW_FILL );
    
     pos.x = rect.ul.x -80;
     pos.y = slider.lr.y;
     PgDrawText(tsk->name, strlen(tsk->name), &pos, 0);
    }
#endif
}

