/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/name.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "defs.h"
#include "abimport.h"
#include "proto.h"

int
setup_cfg( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

     PtArg_t     arg[5];
     char        tmp[20]; 
     nid_t       nodes[MAX_NODES];
     char        *nodes_t[MAX_NODES];
     int         count, i;
     
     count = qnx_name_locators(nodes);
     qsort(nodes, count, sizeof(nid_t), &Comp);
     
     for(i = 0; i < count; i++)
      {
       sprintf(tmp, "%ld", nodes[i]);
       nodes_t[i] = malloc(strlen(tmp)+1);
       if(nodes_t[i] == NULL) // there are not free memory
        {
         count = i;
         break;
        }
       strcpy(nodes_t[i], tmp);
      }
     
     PtSetArg( &arg[0], Pt_ARG_CBOX_ITEMS, nodes_t, count );
     PtSetArg( &arg[1], Pt_ARG_CBOX_SEL_ITEM, 0, 0 );
//     PtSetArg( &arg[2], Pt_ARG_CBOX_EDIT_MASK, "###", 0 );
     
     
     sprintf(tmp, "%ld", node);
     PtSetArg( &arg[2], Pt_ARG_CBOX_TEXT_STRING, &tmp, 0 );
     PtSetResources(ABW_Node, 3, arg);

     for(i = 0; i < count; i++)
      {
       free( nodes_t[i] );
      }

     sprintf(tmp, "%ld", ( rate > 0 ? rate : 500 ));
     PtSetArg( &arg[0], Pt_ARG_TEXT_STRING, &tmp, 0 );
     PtSetResources(ABW_Rate, 1, arg);


	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}


//***************************************************************************
int Comp(nid_t *a, nid_t *b)
{
 if( *a < *b ) return -1;
 else return 1;
}